<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2016, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

class FBCOMMENT_CTRL_Admin extends ADMIN_CTRL_Abstract
{
	public function __construct() {
	parent::__construct();

		if (OW::getRequest()->isAjax()) {
			return;
		}
		
	}

    public function settings()
    {
        $this->setPageHeading(OW::getLanguage()->text('fbcomment', 'admin_settings_heading'));
        $this->setPageHeadingIconClass('ow_ic_gear_wheel');

        $form = new Form('fbcomment_settings');
		
		$config = OW::getConfig();		
		$lang = OW::getLanguage();
		
		$fieldFbAppId = new TextField('fb_app_id');
        $fieldFbAppId->setLabel($lang->text("fbcomment", "fb_app_id_label"));
        $fieldFbAppId->setHasInvitation(true);
        $fieldFbAppId->setInvitation($lang->text('fbcomment', 'fb_app_id_example'));
        $fieldFbAppId->setDescription($lang->text('fbcomment', 'fb_app_id_desc'));
		$form->addElement($fieldFbAppId);
		
		$fieldNumPosts = new TextField('fb_numposts');
        $fieldNumPosts->setLabel($lang->text("fbcomment", "fb_numposts_label"));
        $fieldNumPosts->setRequired(true);
        $fieldNumPosts->setDescription($lang->text('fbcomment', 'fb_numposts_desc'));
		$form->addElement($fieldNumPosts);
		
		$fieldFbAdmin = new TextField('fb_admin');
        $fieldFbAdmin->setLabel($lang->text("fbcomment", "fb_admin_label"));
        $fieldFbAdmin->setDescription($lang->text('fbcomment', 'fb_admin_desc'));
		$form->addElement($fieldFbAdmin);
		
		$fieldDisableFb = new Selectbox('disable_fb');
		$fieldDisableFb->setLabel($lang->text('fbcomment', 'disable_fb_label'));
		$fieldDisableFb->setDescription($lang->text('fbcomment', 'disable_fb_desc'));
		$fieldDisableFb->setOptions(array('yes' => $lang->text('fbcomment', 'admin_option_yes'), 'no' => $lang->text('fbcomment', 'admin_option_no')));
		$form->addElement($fieldDisableFb);
		
		$fieldFbColorScheme = new Selectbox('fb_color_scheme');
		$fieldFbColorScheme->setLabel($lang->text('fbcomment', 'fb_color_scheme_label'));
		$fieldFbColorScheme->setDescription($lang->text('fbcomment', 'fb_color_scheme_desc'));
		$fieldFbColorScheme->setOptions(array('light' => $lang->text('fbcomment', 'admin_option_light'), 'dark' => $lang->text('fbcomment', 'admin_option_dark')));
		$form->addElement($fieldFbColorScheme);
		
        $submit = new Submit('submit');
        $submit->setValue($lang->text('fbcomment', 'save_btn_label'));
        $form->addElement($submit);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) ){
			
            $data = $form->getValues();
			
			$config->saveConfig('fbcomment', 'fb_app_id', trim($data['fb_app_id']));
			$config->saveConfig('fbcomment', 'fb_color_scheme', trim($data['fb_color_scheme']));
			$config->saveConfig('fbcomment', 'disable_fb', trim($data['disable_fb']));
			$config->saveConfig('fbcomment', 'fb_numposts', trim($data['fb_numposts']));
			$config->saveConfig('fbcomment', 'fb_admin', trim($data['fb_admin']));
			
			OW::getFeedback()->info($lang->text('fbcomment', 'admin_successfully_saved'));
            $this->redirect();
        }
		
		$fieldFbAppId->setValue($config->getValue('fbcomment', 'fb_app_id'));
		$fieldFbColorScheme->setValue($config->getValue('fbcomment', 'fb_color_scheme'));
		$fieldDisableFb->setValue($config->getValue('fbcomment', 'disable_fb'));
		$fieldNumPosts->setValue($config->getValue('fbcomment', 'fb_numposts'));
		$fieldFbAdmin->setValue($config->getValue('fbcomment', 'fb_admin'));
		
        $this->addForm($form);
    }
}