<?php
	/**
		* This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
		* For more information see License.txt in the plugin folder.

		* ---
		* Copyright (c) 2016, Ebenezer Obasi
		* All rights reserved.
		* info@eobai.com.

		* Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

		* This plugin should be bought from the developer. For details contact info@eobasi.com.

		* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
		* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
		* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
		* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
		* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
		* AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
		* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	*/
	 
	$gr = OW::getRouter();
	
	$gr->addRoute(new OW_Route('fbcomment_admin_settings', 'admin/plugins/fbcomment/settings', 'FBCOMMENT_CTRL_Admin', 'settings'));
	
	function addFbCommentBox() {

		$config = OW::getConfig();
		$attrs = OW::getDispatcher()->getDispatchAttributes();
		$attrs = $attrs['controller'];
		$langTag = langTag(BOL_LanguageService::getInstance()->getCurrent()->getTag());
		
		$fbAppId = $config->getValue('fbcomment', 'fb_app_id');
		$alreadyHasFb = $config->getValue('fbcomment', 'disable_fb');
		$numPost = $config->getValue('fbcomment', 'data_numposts');
		$colorScheme = $config->getValue('fbcomment', 'fb_color_scheme');
		
		$getAdmins = $config->getValue('fbcomment', 'fb_admin');
		$assignAdmin = explode(',', $getAdmins);
		
		$uri = OW::getRequest()->buildUrlQueryString();
		
		if ( $attrs == 'BLOGS_CTRL_View' || $attrs == 'EVENT_CTRL_Base' || $attrs == 'ADVANCEDBLOGS_CTRL_View' || $attrs == 'VIDEO_CTRL_Video'){
			
			$fbCommentBox = '<div class="fb-comments" href="'.$uri.'" data-width="100%" data-colorscheme="'.$colorScheme.'" data-numposts="'.$numPost.'"></div>';
		
			OW::getDocument()->addMetaInfo('fb:app_id', $fbAppId, 'property');
			
			foreach($assignAdmin as $admin){
				OW::getDocument()->addCustomHeadInfo("<meta property='fb:admins' content='$admin'/>
				");
			}
			
			if (!empty($fbAppId)) {
			
				$script = '<script type="text/javascript">';
				
				$script .= "
					$(document).ready( function(){
					   $('.ow_comments_form_wrap').append( '$fbCommentBox' );
					});
				</script>";
				
				OW::getDocument()->appendBody($script);
				
				if($alreadyHasFb == 'no'){	
				
					$script = '
						<div id="fb-root"></div>
						<script>(function(d, s, id) {
						  var js, fjs = d.getElementsByTagName(s)[0];
						  if (d.getElementById(id)) return;
						  js = d.createElement(s); js.id = id;
						  js.src = "//connect.facebook.net/'.$langTag.'/sdk.js#xfbml=1&version=v2.7&appId='.$fbAppId.'";
						  fjs.parentNode.insertBefore(js, fjs);
						}
					';
					
					$script .= "(document, 'script', 'facebook-jssdk'));</script>";
					
					OW::getDocument()->appendBody($script);
					
				}
			}
		}
		
	}
	
	OW::getEventManager()->bind('core.finalize', 'addFbCommentBox');

	function fbcomment_admin_notification( BASE_CLASS_EventCollector $event ){
		
		$fbAppId = OW::getConfig()->getValue('fbcomment', 'fb_app_id');

		if ( empty($fbAppId) ){
			
			$event->add(OW::getLanguage()->text('fbcomment', 'admin_notification_text', array('link' => OW::getRouter()->urlForRoute('fbcomment_admin_settings'))));
			
		}
		
	}
	OW::getEventManager()->bind('admin.add_admin_notification', 'fbcomment_admin_notification');
	
	function langTag($str) {
		
		return str_replace("-", "_", $str);
		
	}